#include "main.h"


#define BIT_TIME	(XTAL / BAUD)		// 9600 Baud


#ifdef TX_INVERT
#define set_txd(x)	(STXD_PORT = !x)
#else
#define set_txd(x)	(STXD_PORT = x)
#endif


u8 stx_state;
u8 stx_data;


void suart_init( void )
{
  set_txd(1);					// inactive
  STXD_DDR = 1;					// output

  stx_state = 0;
  TCCR1A = 0;
  TCCR1B = 1<<CS10^1<<WGM12;			// clear on OCR1A

  OCR1A = BIT_TIME;
  TIMSK1 = 1<<OCIE1A;
}


NIL(void sputchar( u8 c ))			// no inline in sputs
{
  while( vu8(stx_state) );			// volatile for test
  stx_data = c;
  stx_state = 10;
}


void sputs( u8 *s )
{
  while( *s )
    sputchar( *s++ );
}


ISR( TIM1_COMPA_vect )
{
  switch( stx_state ){
    case 10: set_txd( 0 ); break;		// start bit
    case 9:
    case 8:
    case 7:
    case 6:
    case 5:
    case 4:
    case 3:
    case 2: if( !(stx_data & 1) ){
	      set_txd( 0 );			// data bit 0
	    }else{
    case 1:   set_txd( 1 );			// data bit 1 or stop
	    }
	    stx_data >>= 1;
	    break;
    case 0: return;				// done, do nothing
  }
  stx_state--;
}
